var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

export function withAsyncRouter(BaseComponent) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    _inherits(WithLoadingState, _React$Component);

    function WithLoadingState() {
      _classCallCheck(this, WithLoadingState);

      return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    WithLoadingState.prototype.render = function render() {
      var _ref = this.context.router || {},
          _ref$transitioning = _ref.transitioning,
          transitioning = _ref$transitioning === undefined ? false : _ref$transitioning,
          _ref$preload = _ref.preload,
          preload = _ref$preload === undefined ? function () {
        return null;
      } : _ref$preload;

      return React.createElement(BaseComponent, _extends({}, this.props, {
        transitioning: transitioning,
        preload: preload
      }));
    };

    return WithLoadingState;
  }(React.Component), _class.contextTypes = {
    router: PropTypes.shape({
      transitioning: PropTypes.bool.isRequired,
      preload: PropTypes.func.isRequired
    })
  }, _temp;
}