function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { createLocation } from 'history';

export var Preload = function (_React$Component) {
  _inherits(Preload, _React$Component);

  function Preload() {
    _classCallCheck(this, Preload);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Preload.prototype.componentDidMount = function componentDidMount() {
    this.context.router.preload(this.props.location);
  };

  Preload.prototype.render = function render() {
    return null;
  };

  return Preload;
}(React.Component);
Preload.contextTypes = {
  router: PropTypes.shape({
    preload: PropTypes.func.isRequired
  })
};